function projects = H_projects
%
% Copyright 2012 Guiomar Niso, Ricardo Bruña, Ricardo Gutierrez

% This file is part of HERMES.
% 
% HERMES is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% HERMES is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with HERMES. If not, see <http://www.gnu.org/licenses/>.


% Sets the base path and creates the structure.
path = H_path ( 'p' );
projects = struct ( 'name', {}, 'filename', {} );

directories = dir ( path );

% Checks each folder in the path searching for projects.
for d = 1: numel ( directories )
    if ~directories ( d ).isdir || strcmp ( directories ( d ).name, 'tmp' ) || strcmp ( directories ( d ).name, '.' ) || strcmp ( directories ( d ).name, '..' ), continue, end
    if ~exist ( [ path filesep directories( d ).name filesep 'project' ], 'file' ), continue, end
    
    project = importdata ( [ path filesep directories( d ).name filesep 'project' ] );
    
    % If the folder contains a project takes the metadata.
    if isstruct ( project ) ...
            && isfield ( project, 'version' ) ...
            && strncmp ( project.version, 'HERMES', 6 ) ...
            && strcmp  ( project.filename, directories ( d ).name )
        
        projects ( numel ( projects ) + 1 ).name = project.name;
        projects ( numel ( projects ) ).filename = project.filename;
    end
end