function labels = autolabel ( string, number )

% Checks that 'string' has a valid value.
if ~isstr ( string ) || isempty ( string )
    error ( '''string'' must be a non-empty string.' );
end

% Checks that 'subjects' has a valid value.
if H_checkOR ( number, 'inf', 'nan', '~int', 'lt1' )
    error ( '''subjects'' must take a, integer value greater than zero.' );
end

% Escapes the possible % characters.
string = strrep ( string, '%', '%%' );

% Creates the template from the string and the size of the sample.
template = '%s%%0%0.0f.0f, ';
template = sprintf ( template, string, ceil ( log10 ( number + 1 ) ) );

% Creates a list of comma-separated values for the labels.
labels   = sprintf ( template, 1: number );

% Removes the last two characters (comma and blank space).
labels   = labels ( 1: end - 2 );