function pvalues = myttest2 ( set1, set2 )

% Gets the mirrored matrices.
mir1 = permute ( set1, [ 1 3 2 4 5 ] );
mir2 = permute ( set2, [ 1 3 2 4 5 ] );
symm = all ( set1 (:) == mir1 (:) ) && all ( set2 (:) == mir2 (:) );

% If the matrices are symmetrical checks only the upper triangular.
if symm
    template    = triu   ( true ( H_size ( set1, [ 2 3 ] ) ), 1 );
    triangular  = repmat ( template, H_size ( set1, [ 0 0 4 inf ] ) );
    comparisons = find ( triangular );
    
% Otherwise checks the whole matrix.
else
    comparisons = 1: prod ( H_size ( set1, [ 2 inf ] ) );
end

% Reserves memory for the output data.
pvalues = zeros ( H_size ( set1, [ 2 inf ] ) );

% Performs the statistical analysis.
[ tmp, pvalues( comparisons ) ] = ttest2 ( set1 ( :, comparisons ), set2 ( :, comparisons ) ); %#ok<ASGLU>

% Sets the NaN to 1.
pvalues ( isnan ( pvalues ) ) = 1;

% If the matrices are symmetrical fills the lower triangular.
if symm
    pvalues = pvalues + permute ( pvalues, [ 2 1 3: ndims( pvalues ) ] );
    pvalues = pvalues + ( triangular + permute ( triangular, [ 2 1 3: ndims( triangular ) ] ) == 0 );
end
